## libusermetrics 1.3.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.)

project(libusermetrics VERSION 1.3.2 LANGUAGES CXX)

option (ENABLE_TESTS "Enable testing" ON)

set(API_VERSION 1)
set(ABI_VERSION 1)

set(GETTEXT_PACKAGE libusermetrics)
add_definitions(
	-DGETTEXT_PACKAGE="${GETTEXT_PACKAGE}"
)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")

find_package(PkgConfig REQUIRED)

find_package(Qt5Core REQUIRED)
include_directories(${Qt5Core_INCLUDE_DIRS})

find_package(Qt5Gui REQUIRED)
include_directories(${Qt5Gui_INCLUDE_DIRS})

find_package(Qt5DBus COMPONENTS Qt5DBusMacros REQUIRED)
include_directories(${Qt5DBus_INCLUDE_DIRS})

find_package(Qt5Sql REQUIRED)
include_directories(${Qt5Sql_INCLUDE_DIRS})

find_package(Qt5XmlPatterns REQUIRED)
include_directories(${Qt5XmlPatterns_INCLUDE_DIRS})

pkg_check_modules(APPARMOR REQUIRED libapparmor REQUIRED)
include_directories(${APPARMOR_INCLUDE_DIRS})

pkg_check_modules(GSETTINGS_QT REQUIRED gsettings-qt REQUIRED)
include_directories(${GSETTINGS_QT_INCLUDE_DIRS})

find_package(Qt5Test REQUIRED)
include_directories(${Qt5Test_INCLUDE_DIRS})

find_package(Qt5Qml REQUIRED)
include_directories(${Qt5Qml_INCLUDE_DIRS})

find_package(Qt5Quick REQUIRED)
include_directories(${Qt5Quick_INCLUDE_DIRS})

find_package(Qt5QuickTest REQUIRED)
include_directories(${Qt5QuickTest_INCLUDE_DIRS})

find_package(Intl REQUIRED)

pkg_check_modules(GLIB2 REQUIRED glib-2.0)
include_directories(${GLIB2_INCLUDE_DIRS})

pkg_check_modules(GOBJECT2 REQUIRED gobject-2.0)
include_directories(${GOBJECT2_INCLUDE_DIRS})

option(ENABLE_CLICK "Build with support for click packages" ON)
if(${ENABLE_CLICK})
  pkg_check_modules(CLICK click-0.4 REQUIRED)
  include_directories(${CLICK_INCLUDE_DIRS})
  add_definitions(-DCLICK_ENABLED=1)
endif(${ENABLE_CLICK})

pkg_check_modules(QDJANGO_DB REQUIRED qdjango-db REQUIRED)
include_directories(${QDJANGO_DB_INCLUDE_DIRS})

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(DATA_DIR "${CMAKE_CURRENT_SOURCE_DIR}/data")

set(INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/include")
set(INCLUDE_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/include")
include_directories(${INCLUDE_DIR})
include_directories(${INCLUDE_BINARY_DIR})

set(SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/src")
set(SOURCE_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/src")


include(GNUInstallDirs)

# FIX: Qt was built with -reduce-relocations
if (Qt5_POSITION_INDEPENDENT_CODE)
  SET(CMAKE_POSITION_INDEPENDENT_CODE ON)
endif()

add_definitions(
	-std=c++17
	-fno-permissive
	-pedantic
	-Wall
	-Wextra
	-DLOCALEDIR="${CMAKE_INSTALL_FULL_DATADIR}/locale"
)


add_subdirectory("doc")
add_subdirectory("po")
add_subdirectory("src")
add_subdirectory("data")


if(ENABLE_TESTS)
enable_testing()

pkg_check_modules(QTDBUSTEST REQUIRED libqtdbustest-1 REQUIRED)
include_directories(${QTDBUSTEST_INCLUDE_DIRS})

add_subdirectory(tests)

ADD_CUSTOM_TARGET(
	check
	${CMAKE_CTEST_COMMAND} --force-new-ctest-process --output-on-failure
)

find_package(CoverageReport)
enable_coverage_report(
  TARGETS
    usermetrics-test-utils
    usermetricscommon
    usermetricsinput
    usermetricsinput-static
    usermetricsinput-integration-tests
    usermetricsinput-unit-tests
    usermetricsoutput
    usermetricsoutput-integration-tests
    usermetricsoutput-static
    usermetricsoutput-unit-tests
    usermetricsservice
    usermetricsservice-bin
    usermetricsservice-unit-tests
  FILTER
    ${CMAKE_SOURCE_DIR}/tests/*
    ${CMAKE_BINARY_DIR}/*
  TESTS
    usermetrics-test-utils
    usermetricsinput-integration-tests
    usermetricsinput-unit-tests
    usermetricsoutput-integration-tests
    usermetricsoutput-unit-tests
    usermetricsservice-unit-tests
)

endif()

=== data/CMakeLists.txt ===
find_package(GSettings)

###########################
# Settings
###########################

add_schema("com.lomiri.UserMetrics.gschema.xml")

install(
	DIRECTORY
		libusermetrics
	DESTINATION
		${CMAKE_INSTALL_DATADIR}
)

###########################
# Policy
###########################

set(
	DBUSCONFDIR
	"${CMAKE_INSTALL_SYSCONFDIR}/dbus-1/system.d"
)

install(
	FILES
	"com.lomiri.UserMetrics.conf"
	DESTINATION ${DBUSCONFDIR}
)

###########################
# Dbus Interfaces
###########################

set(
	DBUSIFACEDIR
	"${CMAKE_INSTALL_DATADIR}/dbus-1/interfaces/"
)

install(
	FILES
	com.lomiri.usermetrics.DataSet.xml
	com.lomiri.usermetrics.DataSource.xml
	com.lomiri.usermetrics.UserData.xml
	com.lomiri.UserMetrics.xml
	DESTINATION ${DBUSIFACEDIR}
)

###########################
# Dbus Services
###########################

set(
	DBUSSERVICEDIR
	"${CMAKE_INSTALL_DATADIR}/dbus-1/system-services/"
)

set(USERMETRICS_SERVICE
	"${CMAKE_CURRENT_BINARY_DIR}/com.lomiri.UserMetrics.service"
)

configure_file(
	"com.lomiri.UserMetrics.service.in"
	${USERMETRICS_SERVICE}
	@ONLY
)

install(
	FILES
	${USERMETRICS_SERVICE}
	DESTINATION ${DBUSSERVICEDIR}
)

=== src/CMakeLists.txt ===

include(GenerateExportHeader)

include_directories(${SOURCE_DIR})
include_directories(${SOURCE_BINARY_DIR})

add_compiler_export_flags()

add_subdirectory("libusermetricscommon")
add_subdirectory("libusermetricsinput")
add_subdirectory("libusermetricsoutput")
add_subdirectory("usermetricsservice")
add_subdirectory("modules")

=== src/libusermetricscommon/CMakeLists.txt ===

set(USERMETRICS_COMMON_SOURCES
	DateFactory.cpp
	DateFactoryImpl.cpp
	DBusPaths.cpp
	Localisation.cpp
)

set(USERMETRICS_COMMON_DEPENDENCIES
	Qt5::Core
)

qt5_add_dbus_interface(
	USERMETRICS_COMMON_SOURCES
	"${DATA_DIR}/com.lomiri.UserMetrics.xml"
	UserMetricsInterface
)

qt5_add_dbus_interface(
	USERMETRICS_COMMON_SOURCES
	"${DATA_DIR}/com.lomiri.usermetrics.DataSource.xml"
	DataSourceInterface
)

qt5_add_dbus_interface(
	USERMETRICS_COMMON_SOURCES
	"${DATA_DIR}/com.lomiri.usermetrics.UserData.xml"
	UserDataInterface
)

qt5_add_dbus_interface(
	USERMETRICS_COMMON_SOURCES
	"${DATA_DIR}/com.lomiri.usermetrics.DataSet.xml"
	DataSetInterface
)

add_library(
	usermetricscommon
	STATIC
	${USERMETRICS_COMMON_SOURCES}
)

target_link_libraries(
	usermetricscommon
	${USERMETRICS_COMMON_DEPENDENCIES}
)

=== src/libusermetricsinput/CMakeLists.txt ===

set(EXPORT_FILE_NAME UserMetricsInputExport.h)

FILE(
	GLOB USERMETRICSINPUT_PUBLIC_HEADERS
	RELATIVE "${INCLUDE_DIR}/libusermetricsinput"
	"${INCLUDE_DIR}/libusermetricsinput/*.h"
)

list(
	APPEND USERMETRICSINPUT_PUBLIC_HEADERS
	"${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_FILE_NAME}"
)

set(USERMETRICSINPUT_SOURCES
	Metric.cpp
	MetricImpl.cpp
	MetricManager.cpp
	MetricManagerImpl.cpp
	MetricManagerImpl.cpp
	MetricUpdate.cpp
	MetricUpdateImpl.cpp
	usermetricsinput.cpp
)

set(USERMETRICS_INPUT_DEPENDENCIES
	Qt5::Core
	Qt5::DBus
)

# Static library version of libusermetricsinput

add_library(
	usermetricsinput-static
	STATIC
	${USERMETRICSINPUT_SOURCES}
)

target_link_libraries(
	usermetricsinput-static
	${USERMETRICS_INPUT_DEPENDENCIES}
	usermetricscommon
	${Gettext_LIBRARIES}
)

set_target_properties(
	usermetricsinput-static
	PROPERTIES
	INPUT_NAME usermetricsinput
)

# Shared library version of libusermetricsinput

add_library(
	usermetricsinput
	SHARED
	${USERMETRICSINPUT_SOURCES}
)

generate_export_header(
	usermetricsinput
	EXPORT_FILE_NAME ${EXPORT_FILE_NAME}
)

configure_file(
	"${CMAKE_CURRENT_BINARY_DIR}/${EXPORT_FILE_NAME}"
	"${INCLUDE_BINARY_DIR}/libusermetricsinput/${EXPORT_FILE_NAME}"
)

target_link_libraries(
	usermetricsinput
	${USERMETRICS_INPUT_DEPENDENCIES}
	usermetricscommon
	${Intl_LIBRARIES}
)

set_target_properties(
	usermetricsinput
	PROPERTIES
	VERSION ${API_VERSION}.0.0
	SOVERSION ${ABI_VERSION}
	PUBLIC_HEADER "${USERMETRICSINPUT_PUBLIC_HEADERS}"
)

install(
  TARGETS usermetricsinput
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/libusermetrics-${API_VERSION}/libusermetricsinput"
)

# Package config

set(LIBUSERMETRICSINPUT_PC "libusermetricsinput-${API_VERSION}.pc")
configure_file("libusermetricsinput.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/${LIBUSERMETRICSINPUT_PC}" @ONLY)

install(
  FILES "${CMAKE_CURRENT_BINARY_DIR}/${LIBUSERMETRICSINPUT_PC}"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)

##########################
# Command line interface
##########################

add_executable(
	usermetricsinput-bin
	main.cpp
)

set_target_properties(
	usermetricsinput-bin
	PROPERTIES
	OUTPUT_NAME "usermetricsinput"
)

install(
  TARGETS usermetricsinput-bin
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

target_link_libraries(
	usermetricsinput-bin
	Qt5::Core
	usermetricsinput
)

##########################
# Increment CLI
##########################

add_executable(
	usermetricsinput-increment
	main-increment.cpp
)

install(
  TARGETS usermetricsinput-increment
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

target_link_libraries(
	usermetricsinput-increment
	Qt5::Core
	usermetricsinput
	${Intl_LIBRARIES}
)

=== src/libusermetricsoutput/CMakeLists.txt ===

FILE(
	GLOB USERMETRICSOUTPUT_PUBLIC_HEADERS
	RELATIVE "${INCLUDE_DIR}/libusermetricsoutput"
	"${INCLUDE_DIR}/libusermetricsoutput/*.h"
)

set(USERMETRICSOUTPUT_SOURCES
	ColorTheme.cpp
	ColorThemeImpl.cpp
	ColorThemeProvider.cpp
	GSettingsColorThemeProvider.cpp
	DataSet.cpp
	DataSource.cpp
	SyncedDataSet.cpp
	SyncedDataSource.cpp
	SyncedUserMetricsStore.cpp
	SyncedUserData.cpp
	UserData.cpp
	UserMetrics.cpp
	UserMetricsImpl.cpp
	UserMetricsStore.cpp
	qvariantlistmodel.cpp
)

set(USERMETRICS_OUTPUT_DEPENDENCIES
	Qt5::Core
	Qt5::Gui
	Qt5::DBus
	Qt5::XmlPatterns
)

# Static library version of libusermetricsoutput

add_library(
	usermetricsoutput-static
	STATIC
	${USERMETRICSOUTPUT_SOURCES}
)

target_link_libraries(
	usermetricsoutput-static
	${USERMETRICS_OUTPUT_DEPENDENCIES}
	usermetricscommon
)

set_target_properties(
	usermetricsoutput-static
	PROPERTIES
	OUTPUT_NAME usermetricsoutput
)

# Shared library version of libusermetricsoutput

add_library(
	usermetricsoutput
	SHARED
	${USERMETRICSOUTPUT_SOURCES}
)

target_link_libraries(
	usermetricsoutput
	${USERMETRICS_OUTPUT_DEPENDENCIES}
	usermetricscommon
	${GSETTINGS_QT_LIBRARIES}
	${Gettext_LIBRARIES}
)

set_target_properties(
	usermetricsoutput
	PROPERTIES
	VERSION ${API_VERSION}.0.0
	SOVERSION ${ABI_VERSION}
	PUBLIC_HEADER "${USERMETRICSOUTPUT_PUBLIC_HEADERS}"
)

install(
  TARGETS usermetricsoutput
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/libusermetrics-${API_VERSION}/libusermetricsoutput"
)

# Package config

set(LIBUSERMETRICSOUTPUT_PC "libusermetricsoutput-${API_VERSION}.pc")
configure_file("libusermetricsoutput.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/${LIBUSERMETRICSOUTPUT_PC}" @ONLY)

install(
  FILES "${CMAKE_CURRENT_BINARY_DIR}/${LIBUSERMETRICSOUTPUT_PC}"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)

=== tests/testutils/CMakeLists.txt ===

set(
	USERMETRICS_TEST_UTILS_SRC
	DBusTest.cpp
	QColorPrinter.cpp
	QStringPrinter.cpp
	QVariantPrinter.cpp
	QVariantListPrinter.cpp
	main.cpp
)

add_library(
	usermetrics-test-utils
	SHARED
	${USERMETRICS_TEST_UTILS_SRC}
)

target_link_libraries(
	usermetrics-test-utils
	Qt5::Core
	Qt5::Gui
	Qt5::DBus
	Qt5::Test
	${QTDBUSTEST_LIBRARIES}
)

=== tests/unit/usermetricsservice/CMakeLists.txt ===

set(
	USERMETRICSSERVICE_UNIT_TESTS_SRC
	TestAuthentication.cpp
	TestUserMetricsService.cpp
)

add_executable(
	usermetricsservice-unit-tests
	${USERMETRICSSERVICE_UNIT_TESTS_SRC}
)

target_link_libraries(
	usermetricsservice-unit-tests
	-pthread
	usermetricsservice
	usermetrics-test-utils
	${QTDBUSTEST_LIBRARIES}
	${GTEST_LIBRARIES}
	${GMOCK_LIBRARIES}
)

add_test(
	usermetricsservice-unit-tests
	usermetricsservice-unit-tests
)

=== tests/unit/qml/UserMetricsTest/CMakeLists.txt ===
set(testplugin_SRCS
    TestPlugin.cpp
    DBusQuery.cpp
    MetricInfo.cpp
    )

set(testplugin_HDRS
    TestPlugin.h
    DBusQuery.h
    MetricInfo.h
    )

add_library(usermetrics-qml-test SHARED ${testplugin_SRCS} ${testplugin_HDRS})

target_link_libraries(
        usermetrics-qml-test
        Qt5::Core Qt5::Qml Qt5::Quick
        Qt5::Test Qt5::DBus Qt5::QuickTest
        usermetricsinput-static
        usermetrics-test-utils
        ${GTEST_LIBRARIES}
        ${GMOCK_LIBRARIES}
        )

# copy qmldir file to build dir
configure_file(
	qmldir
	qmldir
)

=== debian/changelog ===
libusermetrics (1.3.2-1build5) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 12 Apr 2024 05:38:44 +0000

libusermetrics (1.3.2-1build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 02:19:28 +0000

libusermetrics (1.3.2-1build3) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 05:42:33 +0000

libusermetrics (1.3.2-1build2) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 23:06:18 +0000

libusermetrics (1.3.2-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:31:18 +0000

libusermetrics (1.3.2-1) unstable; urgency=medium

  [ Marius Gripsgard ]
  * New upstream release
  * debian/patches: Drop upstreamed patch
    - 0001-upgrade-cpp-standard-to-cpp17.patch
  * debian/*: Add patch to use en_US as LANG or LANGUAGE will be
    ignored in latest gettext version. Also add locales-all to B-D
    (closes: #1054997)

 -- Marius Gripsgard <mariogrip@debian.org>  Thu, 01 Feb 2024 04:08:35 +0100

libusermetrics (1.3.0-2) unstable; urgency=medium

  * debian/patches: Add patch to fix FTBFS with googletest 1.13.0
    (closes: #1041135)
  * debian/control: Add myself as uploader

 -- Marius Gripsgard <mariogrip@debian.org>  Thu, 27 Jul 2023 01:01:00 +0200

=== debian/control ===
Source: libusermetrics
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>,
           Marius Gripsgard <mariogrip@debian.org>,
Section: libs
Priority: optional
Build-Depends: cmake,
               cmake-extras,
               dbus,
               debhelper-compat (= 13),
               doxygen,
               gcovr,
               googletest | google-mock,
               intltool,
               lcov,
               libapparmor-dev,
               libclick-dev,
               libgsettings-qt-dev,
               libgtest-dev,
               libqdjango-dev,
               libqt5sql5-sqlite,
               libqt5xmlpatterns5-dev,
               libqtdbustest1-dev,
               pkg-config,
               pkg-kde-tools,
               qml-module-qtquick2,
               qml-module-qttest,
               qtbase5-dev,
               qtdeclarative5-dev,
               sqlite3,
               locales-all
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/ubports-team/libusermetrics/
Vcs-Git: https://salsa.debian.org/ubports-team/libusermetrics.git
Homepage: https://gitlab.com/ubports/development/core/libusermetrics
Rules-Requires-Root: no

Package: usermetricsservice
Architecture: any
Multi-Arch: foreign
Depends: adduser,
         dbus,
         libqt5sql5-sqlite,
         sqlite3,
         ${misc:Depends},
         ${shlibs:Depends}
Description: service exporting anonymous metrics about users
 Libusermetrics enables apps to locally store interesting numerical data
 for later presentation.  For example in the Ubuntu Greeter "flower"
 infographic.
 .
  - All data is stored locally in /var/usermetrics/.
  - No data is centrally collected via a web-serivice or otherwise, and
    no data is sent over the internet.
 .
 The only data that can be stored is numerical, for example "number of
 e-mails" or "number of pictures taken". No personally identifying
 information is stored using this library.
 .
 The Libusermetrics components are used by the Lomiri Operating
 Environment.
 .
 This package contains the service which stores the metrics.

Package: libusermetricsinput-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libusermetricsinput1 (= ${binary:Version}),
         ${misc:Depends}
Description: input library for exporting anonymous metrics about users (header files)
 Libusermetrics enables apps to locally store interesting numerical data
 for later presentation.  For example in the Ubuntu Greeter "flower"
 infographic.
 .
  - All data is stored locally in /var/usermetrics/.
  - No data is centrally collected via a web-serivice or otherwise, and
    no data is sent over the internet.
 .
 The only data that can be stored is numerical, for example "number of
 e-mails" or "number of pictures taken". No personally identifying
 information is stored using this library.
 .
 The Libusermetrics components are used by the Lomiri Operating
 Environment.
 .
 This package contains libusermetricsinput header files that are needed
 to build applications.

Package: libusermetricsinput1
Architecture: any
Multi-Arch: same
Depends: gettext,
         usermetricsservice (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: input library for exporting anonymous metrics about users
 Libusermetrics enables apps to locally store interesting numerical data
 for later presentation.  For example in the Ubuntu Greeter "flower"
 infographic.
 .
  - All data is stored locally in /var/usermetrics/.
  - No data is centrally collected via a web-serivice or otherwise, and
    no data is sent over the internet.
 .
 The only data that can be stored is numerical, for example "number of
 e-mails" or "number of pictures taken". No personally identifying
 information is stored using this library.
 .
 The Libusermetrics components are used by the Lomiri Operating
 Environment.
 .
 This package contain the libusermetricsinput shared library to be
 used by applications.

Package: libusermetricsoutput-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libusermetricsoutput1 (= ${binary:Version}),
         ${misc:Depends}
Description: output library for retrieving anonymous metrics about users (header files)
 Libusermetrics enables apps to locally store interesting numerical data
 for later presentation.  For example in the Ubuntu Greeter "flower"
 infographic.
 .
  - All data is stored locally in /var/usermetrics/.
  - No data is centrally collected via a web-serivice or otherwise, and
    no data is sent over the internet.
 .
 The only data that can be stored is numerical, for example "number of
 e-mails" or "number of pictures taken". No personally identifying
 information is stored using this library.
 .
 The Libusermetrics components are used by the Lomiri Operating
 Environment.
 .
 This package contains libusermetricsoutput header files that are needed
 to build applications.

Package: libusermetricsoutput1
Architecture: any
Multi-Arch: same
Depends: usermetricsservice (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: output library for retrieving anonymous metrics about users
 Libusermetrics enables apps to locally store interesting numerical data
 for later presentation.  For example in the Ubuntu Greeter "flower"
 infographic.
 .
  - All data is stored locally in /var/usermetrics/.
  - No data is centrally collected via a web-serivice or otherwise, and
    no data is sent over the internet.
 .
 The only data that can be stored is numerical, for example "number of
 e-mails" or "number of pictures taken". No personally identifying
 information is stored using this library.
 .
 The Libusermetrics components are used by the Lomiri Operating
 Environment.
 .
 This package contain the libusermetricsoutput shared library to be
 used by applications.

Package: libusermetrics-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: API documentation for libusermetrics
 Libusermetrics enables apps to locally store interesting numerical data
 for later presentation.  For example in the Ubuntu Greeter "flower"
 infographic.
 .
  - All data is stored locally in /var/usermetrics/.
  - No data is centrally collected via a web-serivice or otherwise, and
    no data is sent over the internet.
 .
 The only data that can be stored is numerical, for example "number of
 e-mails" or "number of pictures taken". No personally identifying
 information is stored using this library.
 .
 The Libusermetrics components are used by the Lomiri Operating
 Environment.
 .
 This package installs the libusermetrics API documentation.

Package: libusermetrics-tools
Architecture: any
Depends: libusermetricsinput1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: library for exporting anonymous metrics about users (cmdline tools)
 Libusermetrics enables apps to locally store interesting numerical data
 for later presentation.  For example in the Ubuntu Greeter "flower"
 infographic.
 .
  - All data is stored locally in /var/usermetrics/.
  - No data is centrally collected via a web-serivice or otherwise, and
    no data is sent over the internet.
 .
 The only data that can be stored is numerical, for example "number of
 e-mails" or "number of pictures taken". No personally identifying
 information is stored using this library.
 .
 The Libusermetrics components are used by the Lomiri Operating
 Environment.
 .
 This package contains command line tools to operate the library.

Package: qml-module-usermetrics
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         qml-module-qtquick2,
         libusermetricsinput1 (= ${binary:Version})
Description: QML bindings for libusermetrics
 Libusermetrics enables apps to locally store interesting numerical data
 for later presentation.  For example in the Ubuntu Greeter "flower"
 infographic.
 .
  - All data is stored locally in /var/usermetrics/.
  - No data is centrally collected via a web-serivice or otherwise, and
    no data is sent over the internet.
 .
 The only data that can be stored is numerical, for example "number of
 e-mails" or "number of pictures taken". No personally identifying
 information is stored using this library.
 .
 The Libusermetrics components are used by the Lomiri Operating
 Environment.
 .
 A set of bindings allowing the use of libusermetrics from QML applications.

## libusermetrics 1.3.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.5.)
 
-project(libusermetrics VERSION 1.3.2 LANGUAGES CXX)
+project(libusermetrics VERSION 1.3.3 LANGUAGES CXX)
 
 option (ENABLE_TESTS "Enable testing" ON)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
 	DIRECTORY
 		libusermetrics
 	DESTINATION
-		${CMAKE_INSTALL_DATADIR}
+		${CMAKE_INSTALL_FULL_DATADIR}
 )
 
 ###########################
@@ -19,7 +19,7 @@
 
 set(
 	DBUSCONFDIR
-	"${CMAKE_INSTALL_SYSCONFDIR}/dbus-1/system.d"
+	"${CMAKE_INSTALL_FULL_SYSCONFDIR}/dbus-1/system.d"
 )
 
 install(
@@ -34,7 +34,7 @@
 
 set(
 	DBUSIFACEDIR
-	"${CMAKE_INSTALL_DATADIR}/dbus-1/interfaces/"
+	"${CMAKE_INSTALL_FULL_DATADIR}/dbus-1/interfaces/"
 )
 
 install(
@@ -52,7 +52,7 @@
 
 set(
 	DBUSSERVICEDIR
-	"${CMAKE_INSTALL_DATADIR}/dbus-1/system-services/"
+	"${CMAKE_INSTALL_FULL_DATADIR}/dbus-1/system-services/"
 )
 
 set(USERMETRICS_SERVICE

=== doc/CMakeLists.txt ===
find_package(DoxygenBuilder)

add_doxygen(
    qtdoc
    PROJECT_NAME
        "libusermetrics"
    INPUT
        "${CMAKE_SOURCE_DIR}/include"
        "${CMAKE_CURRENT_SOURCE_DIR}/pages"
    EXAMPLE_PATH
        "${CMAKE_SOURCE_DIR}/examples/"
    STRIP_FROM_PATH
        "${CMAKE_SOURCE_DIR}/include"
    STRIP_FROM_INC_PATH
        "${CMAKE_SOURCE_DIR}/include"
    EXCLUDE_PATTERNS
        */internal/*
    EXCLUDE_SYMBOLS
        *::internal*
        *::Priv
    INSTALL
        ${CMAKE_INSTALL_FULL_DATAROOTDIR}/doc/libusermetrics-doc
    XML
    ALL
)

=== tests/CMakeLists.txt ===
set(CMAKE_AUTOMOC OFF)
find_package(GMock)
set(CMAKE_AUTOMOC ON)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${GMOCK_INCLUDE_DIRS})
include_directories(${GTEST_INCLUDE_DIRS})

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")

add_definitions(-DUSERMETRICSSERVICE_BINARY="${SOURCE_BINARY_DIR}/usermetricsservice/usermetricsservice")

add_definitions(-DTEST_LOCALEDIR="${CMAKE_CURRENT_BINARY_DIR}/data")
add_definitions(-DTEST_DATADIR="${CMAKE_CURRENT_SOURCE_DIR}/data")

add_definitions(-DDATA_DIR="${DATA_DIR}")

add_subdirectory(data)
add_subdirectory(integration)
add_subdirectory(unit)
add_subdirectory(testutils)

=== src/libusermetricsinput/CMakeLists.txt ===
--- 
+++ 
@@ -84,8 +84,8 @@
 
 install(
   TARGETS usermetricsinput
-  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
-  PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/libusermetrics-${API_VERSION}/libusermetricsinput"
+  LIBRARY DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}
+  PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}/libusermetrics-${API_VERSION}/libusermetricsinput"
 )
 
 # Package config
@@ -95,7 +95,7 @@
 
 install(
   FILES "${CMAKE_CURRENT_BINARY_DIR}/${LIBUSERMETRICSINPUT_PC}"
-  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
+  DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig"
 )
 
 ##########################
@@ -115,7 +115,7 @@
 
 install(
   TARGETS usermetricsinput-bin
-  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+  RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
 )
 
 target_link_libraries(
@@ -135,7 +135,7 @@
 
 install(
   TARGETS usermetricsinput-increment
-  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+  RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
 )
 
 target_link_libraries(

=== src/libusermetricsoutput/CMakeLists.txt ===
--- 
+++ 
@@ -76,8 +76,8 @@
 
 install(
   TARGETS usermetricsoutput
-  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
-  PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/libusermetrics-${API_VERSION}/libusermetricsoutput"
+  LIBRARY DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}
+  PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}/libusermetrics-${API_VERSION}/libusermetricsoutput"
 )
 
 # Package config
@@ -87,5 +87,5 @@
 
 install(
   FILES "${CMAKE_CURRENT_BINARY_DIR}/${LIBUSERMETRICSOUTPUT_PC}"
-  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
+  DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig"
 )

=== src/usermetricsservice/CMakeLists.txt ===

set(USERMETRICSSERVICE_SOURCES
	database/DataSet.cpp
	database/DataSource.cpp
	database/UserData.cpp
	Authentication.cpp
	DBusDataSet.cpp
	DBusDataSource.cpp
	DBusUserData.cpp
	DBusUserMetrics.cpp
	TranslationLocatorImpl.cpp
)

qt5_add_dbus_adaptor(
	USERMETRICSSERVICE_SOURCES
	"${DATA_DIR}/com.lomiri.UserMetrics.xml"
	usermetricsservice/DBusUserMetrics.h
	UserMetricsService::DBusUserMetrics
	UserMetricsAdaptor
)

qt5_add_dbus_adaptor(
	USERMETRICSSERVICE_SOURCES
	"${DATA_DIR}/com.lomiri.usermetrics.DataSource.xml"
	usermetricsservice/DBusDataSource.h
	UserMetricsService::DBusDataSource
	DataSourceAdaptor
)

qt5_add_dbus_adaptor(
	USERMETRICSSERVICE_SOURCES
	"${DATA_DIR}/com.lomiri.usermetrics.UserData.xml"
	usermetricsservice/DBusUserData.h
	UserMetricsService::DBusUserData
	UserDataAdaptor
)

qt5_add_dbus_adaptor(
	USERMETRICSSERVICE_SOURCES
	"${DATA_DIR}/com.lomiri.usermetrics.DataSet.xml"
	usermetricsservice/DBusDataSet.h
	UserMetricsService::DBusDataSet
	DataSetAdaptor
)

add_library(
	usermetricsservice
	STATIC
	${USERMETRICSSERVICE_SOURCES}
)

target_link_libraries(
	usermetricsservice
	Qt5::Core
	Qt5::DBus
	Qt5::Sql
	usermetricscommon
	${QDJANGO_DB_LDFLAGS}
	${APPARMOR_LDFLAGS}
	${GLIB2_LDFLAGS}
	${GOBJECT2_LDFLAGS}
	${CLICK_LDFLAGS}
)

############################
# Service executable
############################

add_executable(
	usermetricsservice-bin
	main.cpp
)

set_target_properties(
	usermetricsservice-bin
	PROPERTIES
	OUTPUT_NAME "usermetricsservice"
)

target_link_libraries(
	usermetricsservice-bin
	Qt5::Core
	usermetricsservice
)

#########################
# Installation
#########################

install(
  TARGETS usermetricsservice-bin
  RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_LIBEXECDIR}/libusermetrics"
)

=== tests/data/CMakeLists.txt ===

add_subdirectory(en_FAKELANG)

=== tests/unit/libusermetricsoutput/CMakeLists.txt ===

set(
	USERMETRICSOUTPUT_UNIT_TESTS_SRC
	QModelListener.cpp
	TestColorThemeImpl.cpp
	TestDataSet.cpp
	TestGSettingsColorThemeProvider.cpp
	TestQVariantListModel.cpp
	TestUserMetricsImpl.cpp
	TestSyncedUserMetricsStore.cpp
)

add_executable(
	usermetricsoutput-unit-tests
	${USERMETRICSOUTPUT_UNIT_TESTS_SRC}
)

target_link_libraries(
	usermetricsoutput-unit-tests
	-pthread
	usermetricsoutput-static
	usermetrics-test-utils
	${GSETTINGS_QT_LIBRARIES}
	${GTEST_LIBRARIES}
	${GMOCK_LIBRARIES}
	${Intl_LIBRARIES}
)

add_test(
	usermetricsoutput-unit-tests
	usermetricsoutput-unit-tests
)

=== tests/unit/qml/CMakeLists.txt ===

add_executable(tst_QmlTests tst_QmlTests.cpp)
target_link_libraries(tst_QmlTests Qt5::Core Qt5::Qml Qt5::Quick Qt5::Test Qt5::QuickTest ${TPL_QT5_LIBRARIES})

add_test(tst_QmlTests
	${CMAKE_CURRENT_BINARY_DIR}/tst_QmlTests
	-input ${CMAKE_CURRENT_SOURCE_DIR}
	-import ${SOURCE_BINARY_DIR}/modules
)
set_tests_properties(tst_QmlTests PROPERTIES ENVIRONMENT "QT_QPA_PLATFORM=minimal")

add_subdirectory(UserMetricsTest)

=== tests/data/en_FAKELANG/LC_MESSAGES/CMakeLists.txt ===

find_package(Gettext REQUIRED)

add_custom_command(
	OUTPUT
		foo.mo
	COMMAND
		${GETTEXT_MSGFMT_EXECUTABLE}
		--check
		--output-file foo.mo
		"${CMAKE_CURRENT_SOURCE_DIR}/foo.po"
)

add_custom_target(foo-po-file
	ALL
	DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/foo.mo"
)

=== debian/changelog ===
libusermetrics (1.3.3-2) unstable; urgency=medium

  * debian/control:
    + Move adduser from D: (usermetricsservice) to Pre-D:. The adduser tool
      is used in .preinst script. (Closes: #1102247).
  * debian/rules:
    + Remove build-cruft during dh_clean override. (Closes: #1047856).

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 04 May 2025 21:06:26 +0200

libusermetrics (1.3.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop 0001-tests-Use-en_US.UTF-8-as-gettext-will-ignore-LANGUAG.patch.
      Applied upstream.
  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.
  * debian/control:
    + Bump Standards-Version to 4.7.0. No changes needed.
    + In B-D, switch from pkg-config to pkgconf.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 18 Aug 2024 18:38:47 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: libusermetrics
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders: Mike Gabriel <sunweaver@debian.org>,
            Marius Gripsgard <mariogrip@debian.org>,
 Section: libs
@@ -22,7 +21,7 @@
                libqt5sql5-sqlite,
                libqt5xmlpatterns5-dev,
                libqtdbustest1-dev,
-               pkg-config,
+               pkgconf,
                pkg-kde-tools,
                qml-module-qtquick2,
                qml-module-qttest,
@@ -30,7 +29,7 @@
                qtdeclarative5-dev,
                sqlite3,
                locales-all
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/ubports-team/libusermetrics/
 Vcs-Git: https://salsa.debian.org/ubports-team/libusermetrics.git
 Homepage: https://gitlab.com/ubports/development/core/libusermetrics
@@ -39,8 +38,8 @@
 Package: usermetricsservice
 Architecture: any
 Multi-Arch: foreign
-Depends: adduser,
-         dbus,
+Pre-Depends: adduser,
+Depends: dbus,
          libqt5sql5-sqlite,
          sqlite3,
          ${misc:Depends},

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

ifneq (,$(filter $(DEB_HOST_ARCH),s390x powerpc))
        ENABLE_TESTS = OFF
else
        ENABLE_TESTS = ON
endif

include /usr/share/dpkg/default.mk

%:
	dh $@ --with pkgkde_symbolshelper

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_TESTS=${ENABLE_TESTS}

override_dh_install:
	sed -i debian/tmp/usr/share/doc/libusermetrics-doc/html/* -e "s,$(CURDIR)/,,g"
	sed -i debian/tmp/usr/share/doc/libusermetrics-doc/xml/* -e "s,$(CURDIR)/,,g"
	dh_install

override_dh_clean:
	dh_clean
	-rm po/Makefile.in.in
	-rm po/POTFILES.in

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..
